//*******************************************************************************
//* Dieses Programm wurde von Ulrich Radig fr Atmel AVR C geschrieben  		*
//* 																			*
//* Ich wnsche jeden viel Spa mit diesen kleinen Web-Server der ohne 			*
//* zustzlichen Speicher auskommt.												*
//*																				*
//* Bei Fragen und Verbesserungen wendet euch per EMail an						*
//*																				*
//* mail@ulrichradig.de															*
//*																				*
//* oder im Forum meiner Web Page : www.ulrichradig.de							*
//*																				*
//*******************************************************************************

unsigned char Sendpage = 2;
unsigned int TCP_Socket_Store[10] = {0,0,0,0,0,0,0,0,0,0};
unsigned int TCP_Socket_Status[10] = {0,0,0,0,0,0,0,0,0,0};
PGM_P TCP_Socket_Pointer[10];
PGM_P pointerold;

void tcp_store (char *buffer)
{
	//Variablen Fr die Routine
	unsigned int result16;
	
	//Store seq number to Seq_counter
	Seq_counter = ((buffer[TCP_seqnum] << 8)+buffer[TCP_seqnum+1]);
	Seq_counter = Seq_counter << 16;
	Seq_counter = Seq_counter +(unsigned) ((buffer[TCP_seqnum+2] << 8)+buffer[TCP_seqnum+3]);

    //Store ack number to ACK_counter
	Ack_counter = ((buffer[TCP_acknum] << 8)+buffer[TCP_acknum+1]);
	Ack_counter = Ack_counter << 16;
	Ack_counter = Ack_counter +(unsigned) ((buffer[TCP_acknum+2] << 8)+buffer[TCP_acknum+3]);

	//Calculate next seq number
	if ((buffer[TCP_hdrflags+1]&FIN_Flag) == 0)
		{
		result16 = (buffer[ip_pktlen]<<8) + buffer[ip_pktlen+1];
		result16 = result16 - ((buffer[ip_vers_len] & 0x0F) << 2) - ((buffer[TCP_hdrflags] & 0xF0) >>2);

		if ((buffer[TCP_hdrflags+1]&SYN_Flag) > 0
		&& result16 == 0)
			{
			result16 = 1;
			}
		Seq_counter =Seq_counter + result16;
		}
}

void tcp_add_data (PGM_P pointer,char *buffer,int *bufferlen)
{
	//Variablen Fr die Routine
	unsigned int result16;
	unsigned char Data = 1;


	//Errechnet startpunkt der Daten im Tcp buffer
	//IP Headerlnge + TCP Headerlnge + Ethernetframe
	result16 = ((buffer[ip_vers_len] & 0x0F) << 2) + ((buffer[TCP_hdrflags] & 0xF0) >>2) + 14;
	
	Sendpage = 0;
	for(;;)
		{
		Data = pgm_read_byte(pointer++);
		buffer[result16] = Data;
		result16++;
			//sind die daten lnger als ein Ethernetbuffer 
			if (result16 > 1400)
				{
				Sendpage = 1;
				//Speichern des Pointers
				pointerold = pointer;
				//Abbruch der Schleife
				break;
				}
			if (pgm_read_byte(pointer)=='%' && pgm_read_byte(pointer+1)=='E' && pgm_read_byte(pointer+2) =='N'&& pgm_read_byte(pointer+3)=='D')
				{
				break;
				}
		}
		
	//addiert noch bufferheader zur neuen ethernetlnge
	result16 = result16 + 4;
	*bufferlen = result16;
	//Errechnet die neue ip bufferlnge aus Ethernet Lnge - Ethernetframe - bufferheader
	result16 = result16 - 18;
	//schreibt neue IPlnge ins buffer (ip_pktlenH)
	buffer[ip_pktlen] = ((result16 & 0xFF00) >> 8);
	//schreibt neue IPlnge ins buffer (ip_pktlenL)
	buffer[ip_pktlen+1] = (result16 & 0x00FF);
}

void tcp_make (char *buffer)
{
	//Variablen Fr die Routine
	unsigned int result16;
	unsigned long result32 = 0x00000000;
	unsigned char DataH;
	unsigned char DataL;

	//Schreibt neuen seq und Ack Counter	
    buffer[TCP_acknum] = (Seq_counter & 0xFF000000) >> 24;
    buffer[TCP_acknum+1] = (Seq_counter & 0x00FF0000) >> 16;
    buffer[TCP_acknum+2] = (Seq_counter & 0x0000FF00) >> 8;
    buffer[TCP_acknum+3] = Seq_counter & 0x000000FF;

    buffer[TCP_seqnum] = (Ack_counter & 0xFF000000) >> 24;
    buffer[TCP_seqnum+1] = (Ack_counter & 0x00FF0000) >> 16;
    buffer[TCP_seqnum+2] = (Ack_counter & 0x0000FF00) >> 8;
    buffer[TCP_seqnum+3] = Ack_counter & 0x000000FF;

    //Tauscht den TCP source Port mit TCP destinations port 0080 >> XXXX

	DataH = buffer[TCP_srcport];
    buffer[TCP_srcport] = buffer[TCP_destport];
    buffer[TCP_destport] = DataH;

	DataL = buffer[TCP_srcport+1];
    buffer[TCP_srcport+1] = buffer[TCP_destport+1];
    buffer[TCP_destport+1] = DataL;

	//Erzeugt den IP Header	
    ip(buffer);

	//Berechnung der TCP Checksumme
	//Alle Daten im TCP Header werden addiert checksum wird deshalb
	//ersteinmal auf null gesetzt
	buffer[tcp_chksum] = 0x00;
	buffer[tcp_chksum+1] = 0x00;

	//Berechnet Headerlnge und Addiert Pseudoheaderlnge 2XIP = 8
	result16 = (buffer[ip_pktlen]<<8) + buffer[ip_pktlen+1] + 8;
	result16 = result16 - ((buffer[ip_vers_len] & 0x0F) << 2);
	result32 = result16 - 2;

	//Pointer wird auf das erste buffer im IP Header gesetzt
	//Routine berechnet die Checksumme
	result16 = checksum (&buffer[ip_srcaddr], result16, result32);

	//schreibt checksum ins buffer (INT H Byte)
	buffer[tcp_chksum] = ((result16 & 0xFF00) >> 8);

	//schreibt checksum ins buffer (INT L Byte)
	buffer[tcp_chksum+1] = (result16 & 0x00FF);

	//Habe Fertig!!
}

void TCP_PORT_CLOSE (char *buffer,int *bufferlen)
{
	//Speichert Sequenzcounter und Aknowledgecounter
	tcp_store(buffer);		
	//Setzen des FIN Flag
	buffer[TCP_hdrflags+1] |= FIN_Flag;
	//Erzeugt ein TCP buffer 
	tcp_make(buffer);			
	//Sendet das erzeugte TCP buffer 
	Write_Ethernet_Frame (buffer,*bufferlen);
}

int TCP_OPEN (char *buffer,int *bufferlen)
{
	if ((buffer[TCP_hdrflags+1] & SYN_Flag) > 0 
	&& (buffer[TCP_hdrflags+1] & PSH_Flag) == 0 
	&& (buffer[TCP_hdrflags+1] & ACK_Flag) == 0)
	{
		//Speichern des Socket
		int a;
		for (a=0;a<10;a++)
			{
			if (TCP_Socket_Store[a] == 0)
				{
				TCP_Socket_Store[a] = (buffer[TCP_srcport]<<8) + buffer[TCP_srcport+1];
				TCP_Socket_Status[a] = 0;
				break;
				}
			if (a == 9)
				{
				for (int b = 0;b<10;b++)
					{
					TCP_Socket_Store[b] = 0;
					TCP_Socket_Status[b] = 0;
					}
				a = 0;
				}
			}
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);		
		//Setzen des Ack Flag
		buffer[TCP_hdrflags+1] |= ACK_Flag;
		//Erzeugt ein TCP buffer 
		tcp_make(buffer);			
		//Sendet das erzeugte TCP buffer 
		Write_Ethernet_Frame (buffer,*bufferlen);
		printf("TCP Socket Open %d : %d \n",TCP_Socket_Store[a],a);
		return(1);
	}
		
	if ((buffer[TCP_hdrflags+1]&RST_Flag) > 0) 
	{
	for (int a=0;a<10;a++)
		{
		if (TCP_Socket_Store[a] == (buffer[TCP_srcport]<<8) + buffer[TCP_srcport+1])
			{
			TCP_Socket_Store[a] = 0;
			break;
			}
		}
		return(1);
	}
		
	if ((buffer[TCP_hdrflags+1]&FIN_Flag) > 0) 
	{
		for (int a=0;a<10;a++)
		{
		if (TCP_Socket_Store[a] == (buffer[TCP_srcport]<<8) + buffer[TCP_srcport+1])
			{
			TCP_Socket_Store[a] = 0;
			break;
			}
		}
		//Speichert Sequenzcounter und Aknowledgecounter
		tcp_store(buffer);
		//Setzen des Ack Flag
		buffer[TCP_hdrflags+1] = ACK_Flag;
		//Erzeugt ein TCP buffer 
		tcp_make(buffer);			
		//Sendet das erzeugte TCP buffer 
		Write_Ethernet_Frame (buffer,*bufferlen);	
		return(1);
	}
return(0);
}
